// -------------------------------------------------------------------------------
// 
// 		cwCu		Xbh֌WvOwb_t@C
// 
// 				Ver 3.20 
// 
// -------------------------------------------------------------------------------

#ifndef __DXTHREAD_H__
#define __DXTHREAD_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"

#ifdef __WINDOWS__
#include "Windows/DxThreadWin.h"
#endif // __WINDOWS__

#ifdef __ANDROID__
#include "Android/DxThreadAndroid.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxThreadiOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__




#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// D揇
#define DX_THREAD_PRIORITY_LOWEST			(0)
#define DX_THREAD_PRIORITY_BELOW_NORMAL		(1)
#define DX_THREAD_PRIORITY_NORMAL			(2)
#define DX_THREAD_PRIORITY_HIGHEST			(3)
#define DX_THREAD_PRIORITY_NUM				(4)

#if !defined( __BCC ) || defined( _DEBUG )
	#define CRITICALSECTION_LOCK( csection )			CriticalSection_Lock( (csection), __FILE__, __LINE__ )
#else
	#define CRITICALSECTION_LOCK( csection )			CriticalSection_Lock( (csection) )
#endif

// ^` ------------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

extern	void		Thread_Initialize( void ) ;																				// Xbh̏
extern	int			Thread_Create( THREAD_INFO *pThreadInfo, void ( *pFunction )( THREAD_INFO *, void * ), void *pParam ) ;	// Xbh쐬
extern	void		Thread_Delete( THREAD_INFO *pThreadInfo ) ;																// Xbȟns
extern	int			Thread_IsValid( THREAD_INFO *pThreadInfo ) ;															// XbhLǂ擾( 1:L  0: )
extern	void		Thread_SetPriority( THREAD_INFO *pThreadInfo, int Priority /* DX_THREAD_PRIORITY_LOWEST Ȃ */ ) ;		// Xbh̎sD揇ʂݒ肷
extern	DWORD_PTR	Thread_GetCurrentId( void ) ;																			// JgXbĥhc擾
extern	DWORD_PTR	Thread_GetId( THREAD_INFO *pThreadInfo ) ;																// Xbĥhc擾
extern	void		Thread_Suspend( THREAD_INFO *pThreadInfo ) ;															// Xbhx~Ԃɂ
extern	int			Thread_Resume( THREAD_INFO *pThreadInfo ) ;																// Xbh̋x~Ԃ( 0:x~ԂȂ  1:x~Ԃ )

extern	void		Thread_Sleep( DWORD MiliSecond ) ;																		// w莞ԃXbh~

extern	int			CriticalSection_Initialize( DX_CRITICAL_SECTION *pCSection ) ;									// NeBJZNV̏
extern	int			CriticalSection_Delete( DX_CRITICAL_SECTION *pCSection ) ;										// NeBJZNV̍폜

#if !defined( __BCC ) || defined( _DEBUG )
extern	int			CriticalSection_Lock( DX_CRITICAL_SECTION *pCSection, const char *FilePath, int LineNo ) ;		// NeBJZNṼbN̎擾
#else
extern	int			CriticalSection_Lock( DX_CRITICAL_SECTION *pCSection ) ;										// NeBJZNṼbN̎擾
#endif
extern	int			CriticalSection_Unlock( DX_CRITICAL_SECTION *pCSection ) ;										// NeBJZNṼbN

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // __DXTHREAD_H__
